/* 
** AUTHORS: 
** Rama Alebouyeh (rama[at]cs.ucsb.edu)
** Matthew S Allen (msa[at]cs.ucsb.edu)
*/

#ifndef _CHIMERA_LOG_H_
#define _CHIMERA_LOG_H_

enum {
  LOG_ERROR,          /* error messages (stderr) */
  LOG_WARN,           /* warning messages (none) */
  LOG_DEBUG,          /* debugging messages (none) */
  LOG_KEYDEBUG,       /* debugging messages for key subsystem */
  LOG_NETWORKDEBUG,   /* debugging messages for network layer */
  LOG_ROUTING,        /* debugging the routing table */
  LOG_COUNT           /* count of log message types */
};

void log_message(int type, char *format, ...);
void log_direct(int type, FILE *fp);

#endif /* _CHIMERA_LOG_H_ */

