
/* 
** AUTHORS: 
** Rama Alebouyeh (rama[at]cs.ucsb.edu)
** Matthew S Allen (msa[at]cs.ucsb.edu)
*/

#ifndef _CHIMERA_MESSAGE_H_
#define _CHIMERA_MESSAGE_H_

#include "key.h"
#include "host.h"

typedef struct {
  Key dest;
  int type;
  int size;
  char *payload;
} Message;

typedef void (*messagehandler_t)(Message *);

int message_init(int port);
void message_recieved(char *data, int size);
void message_handler(int type, messagehandler_t func);
int message_send(ChimeraHost *host, Message *message);
Message *message_create(Key dest, int type, int size, char *payload);

#endif /* _CHIMERA_MESSAGE_H_ */
