/* 
** AUTHORS: 
** Rama Alebouyeh (rama[at]cs.ucsb.edu)
** Matthew S Allen (msa[at]cs.ucsb.edu)
*/

#ifndef _CHIMERA_NETWORK_H_
#define _CHIMERA_NETWORK_H_

#define NETWORK_PACK_SIZE 65536

#include "host.h"

unsigned long network_address(char *);

/*
** network_init: int port
** Returns an integer file descriptor of a UDP socket bound to #port# on
** success, and a -1 on failure. Logs an error report of the reason for
** failure.
*/

/* network_init:port 
** initiates the networking layer by creating socket and bind it to #port# */
int network_init(int);


/*
** network_activate: 
** NEVER RETURNS. Puts the network layer into listen mode. This thread
** manages acknowledgements, delivers incomming messages to the message
** handler, and drives the network layer. It should only be called once.
*/

void *network_activate();

/*
** network_send: host, data, size
** Sends a message to host, updating the measurement info.
*/

int network_send(ChimeraHost *, char *, int);

#endif /* _CHIMERA_NETWORK_H_ */
